Option TargetCPU zx1281e
Option ExtRamConfig On
Option PortPinEncoding Off
Option TaskStackMargin 12
Option RamSize 64*1024-Register.RamStart
Option HeapSize 500


public Asem as boolean

public task1stack (1 to 100 ) as byte
public task2stack (1 to 100 ) as byte

Sub Main()
	sleep 0.5
	Asem = false
	calltask task1, task1stack
	calltask task2, task2stack
End Sub

sub common(byval which as byte)
 	debug.print
	debug.print "O from ";cstr(which); ", sem=";cstr(Asem)
	sleep 0.5
 
 	debug.print "F from ";cstr(which); ", sem=";cstr(Asem)
	sleep 0.5	
end sub


sub task1()
	do 
		waitForSem(Asem)
		common 1
		resetSem(Asem)
		sleep rnd()
	loop
end sub


sub task2()
	do 
		waitForSem(Asem)
		common 2
		resetSem(Asem)
		sleep rnd()
	loop
end sub

sub waitForSem(byval sem as boolean)
	do until ( Semaphore(sem) )
		sleep 0.0
	loop
end sub

sub resetSem(byref sem as boolean)
	sem = false
end sub
